/*
 *  OpenGLDraw2D.cpp
 *  SampleScreenSaver
 *
 *  Created by гык-sse2 on 11.07.10.
 *  Copyright 2010 Гимназия 1542. All rights reserved.
 *
 */
#include "stdafx.h"
//#include <sstream>
//#include <iostream>

#include "consolation.h"

SDL_Surface* gScreen;
#define		pi			3.1415

GLvoid*		font_style	=GLUT_BITMAP_8_BY_13;
PTFillStyle	fillStyle;
float		fillColorR,	fillColorG,	fillColorB;
float		drawColorR,	drawColorG,	drawColorB;
float		backColorR,	backColorG,	backColorB;
float		textColorR,	textColorG,	textColorB;
float		textBackR,	textBackG,	textBackB;
int			x=0;
int			y=13;
int			hsize;
int			vsize;
char		symbol;
bool		keyWasPressed=false;
int			keyScanCode;
int			keyUnicode;

void refreshscreen() {
	glFlush();
	SDL_GL_SwapBuffers();
}


void initgraph (int hsize, int vsize, bool fullscreen, int* argc, char** argv) {
	::hsize=hsize;
	::vsize=vsize;
	if ( SDL_Init (SDL_INIT_VIDEO) < 0 ) 		
        exit(1);
	SDL_InitSubSystem(SDL_INIT_TIMER);
	SDL_GL_SetAttribute (SDL_GL_DEPTH_SIZE, 1);
    
    Uint32 flags = SDL_OPENGL;
    if (fullscreen)
        flags |= SDL_FULLSCREEN;  		
	
	//SDL_GL_SetAttribute(SDL_GL_DOUBLEBUFFER, 1);
	//SDL_GL_SetAttribute(SDL_GL_SWAP_CONTROL, 1);
	
    gScreen = SDL_SetVideoMode (hsize, vsize, 32, flags);
	
    if (!gScreen) {		
        SDL_Quit();
		exit(2);
	}
	glMatrixMode (GL_PROJECTION);
	glLoadIdentity ();
	glOrtho (0, hsize, vsize, 0, 0, 1);
	glDisable(GL_DEPTH_TEST);
	glMatrixMode (GL_MODELVIEW);
	glLoadIdentity();
	// Displacement trick for exact pixelization
	glTranslatef(0.375, 0.375, 0);
	glDrawBuffer(GL_FRONT_AND_BACK);
	setbkcolor(BLACK);
	setcolor(WHITE);
	setfillstyle(SOLID_FILL, WHITE);
	textcolor(WHITE);
	textbackground(BLACK);

#ifdef PT_GLUT_NEEDS_INIT
	glutInit(argc, argv);
#endif

	ptprintf("%s","This project is using Consolation - Paztalom Technologiez console emulation and graphics library");
	delay(1000);
	clrscr();
}

void closegraph(){
	SDL_Quit();
}

void cleardevicenorefresh () {
	glClearColor(backColorR, backColorG, backColorB, 0);
	glClear(GL_COLOR_BUFFER_BIT);	
}

void cleardevice () {
	cleardevicenorefresh();
	refreshscreen();
}

void putpixel(float x1, float y1){
	setcolor(drawColorR, drawColorG, drawColorB);
	glBegin(GL_POINTS);
	glVertex2f(x1, y1);
	glEnd();
	refreshscreen();
}

void line(float x1,float y1,float x2,float y2){
	setcolor(drawColorR, drawColorG, drawColorB);
	glBegin(GL_LINES);
	glVertex2f(x1, y1); glVertex2f(x2, y2);
	glEnd();
	refreshscreen();
}

void bar(float x1,float y1,float x2,float y2){
	float r=drawColorR, g=drawColorG, b=drawColorB;
	switch(fillStyle) {
		case SOLID_FILL:
			setcolor(fillColorR, fillColorG, fillColorB);
			glBegin(GL_QUADS);
			glVertex2f(x1, y1); glVertex2f(x2, y1); glVertex2f(x2, y2); glVertex2f(x1, y2);
			glEnd();
			break;
		case NONE:
		default:
			break;
	}
	setcolor(r,g,b);
	glBegin(GL_LINE_LOOP);
	glVertex2f(x1, y1); glVertex2f(x2, y1); glVertex2f(x2, y2); glVertex2f(x1, y2);
	glEnd();
	refreshscreen();
}

void fillpoly(int n, float* array){
	float r=drawColorR, g=drawColorG, b=drawColorB;
	switch(fillStyle){
		case SOLID_FILL:
			setcolor(fillColorR, fillColorG, fillColorB);
			glBegin(GL_POLYGON);
			for (int i=0; i<n; i++) 
				glVertex2f(array[2*i], array[2*i+1]);
			glEnd();
			break;
		case NONE:
		default:
			break;
	}
	setcolor(r,g,b);
	glBegin(GL_LINE_LOOP);
	for (int i=0; i<n; i++) 
		glVertex2f(array[2*i], array[2*i+1]);
	glEnd();
	refreshscreen();
}

void outtextxy (float x, float y, const char* string) {
	::x=x;
	::y=y;
	outtext(string);
}

void outtext (const char* string) {
	setcolor(drawColorR, drawColorG, drawColorB);
	glRasterPos2f(x, y);
	GLvoid		*font_style	=GLUT_BITMAP_8_BY_13;
	for (int i = 0; string[i] != '\0'; i++) {
		switch (string[i]) {
			case '\n':
				if (y+13<vsize) {
					x=0;
					y+=13;
				}
				else 
					clrscr();
				break;
			case '\r':
				x=0;
				break;
			default:
				glutBitmapCharacter(font_style, string[i]);
				if (x+8<hsize)
					x+=8;
				else if(y+13<vsize) {
					x=0;
					y+=13;
				}else
					clrscr();
				glRasterPos2f(x, y);				
		}		
	}
	refreshscreen();
}

void gotoxy (float x, float y) {//Coordinates in Symbols, not in Pixels
	::x=8*x;
	::y=13*y;
	glRasterPos2f (::x, ::y);
}

void setfillstyle(PTFillStyle newStyle, float R, float G, float B) {
	fillStyle=newStyle;
	fillColorR=R;
	fillColorG=G;
	fillColorB=B;
}

void fillellipse(float x0, float y0, float r1, float r2) {
    float x, y;
	float r=drawColorR, g=drawColorG, b=drawColorB;
	switch (fillStyle) {
		case SOLID_FILL:
			setcolor(fillColorR, fillColorG, fillColorB);
			glBegin(GL_TRIANGLE_FAN);
			glVertex2f(x0, y0);
			for(int i = 0; i < 360.0; i++) {
				x = x0+r1 * sin(i/360.0 * pi*2.0);
				y = y0+r2 * cos(i/360.0 * pi*2.0);
				glVertex2f(x, y);
			}
			glEnd();
			setcolor(r,g,b);
			break;
		case NONE:
		default:			
			break;
	}
	glBegin(GL_LINE_LOOP);
	for(int i = 0; i < 360.0; i++) {
        x = x0+r1 * sin(i/360.0 * pi*2.0);
        y = y0+r2 * cos(i/360.0 * pi*2.0);
        glVertex2f(x, y);
    }
	glEnd();
	refreshscreen();
}

void setbkcolor (float r, float g, float b){
	backColorR=r;
	backColorG=g;
	backColorB=b;
	cleardevice();
}

void setcolor (float r, float g, float b){
	drawColorR=r;
	drawColorG=g;
	drawColorB=b;
	glColor3f(r,g,b);
}


void clrscr () {
	cleardevice();
	x=0;
	y=13;
}

char getch () {
	SDL_Event event;
	SDL_EnableUNICODE(SDL_ENABLE);
	do SDL_WaitEvent(&event);
	while ((event.type!=SDL_KEYDOWN)||!(event.key.keysym.unicode));
	SDL_EnableUNICODE(SDL_DISABLE);
	return event.key.keysym.unicode;
}

char getche () {
	char c=getch();
	putch(c);
	return c;
}

int putch (char symbol) {
	ptprintf("%c",symbol);
	return 0;
}

int ptputs (const char* string) {
	ptprintf("%s\n",string);
	return 0;
}

char* ptgets (char* string) {
	int i=0;
	do {
		string[i]=getche();
		i++;
	} while ((string[i-1]!='\r')&&(string[i-1]!='\n'));
	string[i-1]='\0';
	ptprintf("\n");
	return string;
}

void catchevents () {
	SDL_Event event;
	SDL_EnableUNICODE(SDL_ENABLE);
	SDL_PollEvent(&event);
	switch (event.type) {
		case SDL_KEYDOWN:
			keyWasPressed=true;
			keyScanCode=event.key.keysym.scancode&0x7f;
			keyUnicode=event.key.keysym.unicode&0x7f;
			putch(keyUnicode);
			break;
		case SDL_QUIT:
			closegraph();
			exit(0);
			break;
		default:
			break;
	}
	SDL_EnableUNICODE(SDL_DISABLE);
}

int bioskey(int command) {
	SDL_Event event;
	SDL_EnableUNICODE(SDL_ENABLE);
	uint32_t k=0;
	switch (command) {
		case 0:
			if (keyWasPressed){
				keyWasPressed=false;
				k=(keyScanCode<<8)||keyUnicode;
			}
			do SDL_WaitEvent(&event);
			while (event.type!=SDL_KEYDOWN);
			SDL_EnableUNICODE(SDL_DISABLE);
			k=((event.key.keysym.scancode&0x7f)<<8)|(event.key.keysym.unicode&0x7f);
			break;
		case 1:
			if (keyWasPressed)
				k=(keyScanCode<<8)||keyUnicode;
			break;
		case 2:
		default:
			break;
	}
	SDL_EnableUNICODE(SDL_DISABLE);
	return k;
}

void PTPointArray (float* array, int n) {
	setcolor(drawColorR, drawColorG, drawColorB);
	glBegin(GL_POINTS);
	for (int i=0; i<n; i++)
		glVertex2f(array[2*i], array[2*i+1]);
	glEnd();
	refreshscreen();
}

void PTLinedPointArray (float* array, int n) {
	setcolor(drawColorR, drawColorG, drawColorB);
	glBegin(GL_LINE_STRIP);
	for (int i=0; i<n; i++)
		if (array[2*i]&&array[2*i+1])
			glVertex2f(array[2*i], array[2*i+1]);
	glEnd();
	refreshscreen();
}

void	ptprintf		(const char* format, ...){
	va_list ap;
	va_start(ap, format);
#ifdef WIN32
	int len = _vscprintf(format, ap)+1;
	char* string = new char[len];
   	vsprintf(string, format, ap);


#else
	char* string;
	vasprintf(&string, format, ap);
#endif
	float r=drawColorR, g=drawColorG, b=drawColorB;
	
	int i=-1, length=0, xbak=x, ybak=y, dy=0;
	do {
		i++;
		if ((string[i]=='\n')||(string[i]=='\0')){
			
			PTFillStyle backupStyle=fillStyle;
			setfillstyle(SOLID_FILL, textBackR, textBackG, textBackB);
			setcolor(textBackR, textBackG, textBackB);
			bar(x, y-10, x+8*length, y+3);
			setfillstyle(backupStyle, r, g, b);
			setcolor(textColorR, textColorG, textColorB);
			
			length=0;
			if(y+13<vsize) {
				x=0;
				y+=13;
				
			}else{
				char* rect=new char[4*hsize*vsize];
				glReadPixels(0, 0, hsize, vsize, GL_RGBA, GL_BYTE, rect);
				glRasterPos2f(0, vsize-13);
				cleardevicenorefresh();
				glDrawPixels(hsize, vsize, GL_RGBA, GL_BYTE, rect);
				delete[] rect;
				x=0;
			}
			dy+=13;
		}
		else
			length++;
		
	}while (string[i]!=0);
	x=xbak;
	y-=dy;
	setcolor(textColorR, textColorG, textColorB);//why didn't it make effect on the first symbol in its usual place?
	for (int i = 0; i<strlen(string); i++) {
		switch (string[i]) {
			case '\n':
			case '\r':
				if (y+13<vsize) {
					x=0;
					y+=13;
				}
				else {
					char* rect=new char[4*hsize*vsize];
					glReadPixels(0, 0, hsize, vsize, GL_RGBA, GL_BYTE, rect);
					glRasterPos2f(0, vsize-13);
					cleardevicenorefresh();
					glDrawPixels(hsize, vsize, GL_RGBA, GL_BYTE, rect);
					delete[] rect;
					x=0;
				}
				break;
			//case '\r':
				//x=0;
				//break;
			default:
				glRasterPos2f (x, y);
				glutBitmapCharacter(font_style, string[i]);
				if (x+8<hsize)
					x+=8;
				else if(y+13<vsize) {
					x=0;
					y+=13;
				}else{
					char* rect=new char[4*hsize*vsize];
					glReadPixels(0, 0, hsize, vsize, GL_RGBA, GL_BYTE, rect);
					glRasterPos2f(0, vsize-13);
					cleardevicenorefresh();
					glDrawPixels(hsize, vsize, GL_RGBA, GL_BYTE, rect);
					delete[] rect;
					x=0;
				}
				glRasterPos2f(x, y);				
		}		
	}
	refreshscreen();
	setcolor(r,g,b);
	delete[] string;
}

#ifndef WIN32
void ptscanf (const char* format, ...){
	va_list ap;
	va_start(ap, format);
	char* string=new char[80];
	ptgets(string);
	vsscanf(string, format, ap);
	delete[] string;
}
#endif

void bar3d (float x1, float y1, float x2, float y2, float depth, bool topflag){
	bar(x1,y1,x2,y2);
	if (topflag) {
		glBegin(GL_LINE_STRIP);
		glVertex2f(x1,			y1);
		glVertex2f(x1+depth,	y1-depth*tan(pi*36.0/180.0));
		glVertex2f(x2+depth,	y1-depth*tan(pi*36.0/180.0));
		glVertex2f(x2+depth,	y2-depth*tan(pi*36.0/180.0));
		glVertex2f(x2,			y2);
		glEnd();
		glBegin(GL_LINES);
		glVertex2f(x2,			y1);
		glVertex2f(x2+depth,	y1-depth*tan(pi*36.0/180.0));
		glEnd();
	}
	else {
		glBegin(GL_LINES);
		glVertex2f(x2,			y2);
		glVertex2f(x2+depth,	y2-depth*tan(pi*36.0/180.0));
		glEnd();
	}

	refreshscreen();
}

void delay(int ms){
	SDL_Delay(ms);
}


IOXTream& IOXTream::operator>> (bool& val ){
	char string[80];
	int i=-1;
	do {
		i++;
		string[i]=getche();
	} while ((string[i]!=' ')&&(string[i]!='\n')&&(string[i]!='\r'));
	string[i]='\0';
	sscanf(string, "%d", &i);
	val=!(!i);
	return *this;
}

IOXTream& IOXTream::operator>> (short& val ){
	char string[80];
	int i=-1;
	do {
		i++;
		string[i]=getche();
	} while ((string[i]!=' ')&&(string[i]!='\n')&&(string[i]!='\r'));
	string[i]='\0';
	sscanf(string, "%d", &val);
	return *this;
}

IOXTream& IOXTream::operator>> (unsigned short& val ){
	char string[80];
	int i=-1;
	do {
		i++;
		string[i]=getche();
	} while ((string[i]!=' ')&&(string[i]!='\n')&&(string[i]!='\r'));
	string[i]='\0';
	sscanf(string, "%d", &val);
	return *this;
}

IOXTream& IOXTream::operator>> (int& val ){
	char string[80];
	int i=-1;
	do {
		i++;
		string[i]=getche();
	} while ((string[i]!=' ')&&(string[i]!='\n')&&(string[i]!='\r'));
	string[i]='\0';
	sscanf(string, "%d", &val);
	return *this;
}

IOXTream& IOXTream::operator>> (unsigned int& val ){
	char string[80];
	int i=-1;
	do {
		i++;
		string[i]=getche();
	} while ((string[i]!=' ')&&(string[i]!='\n')&&(string[i]!='\r'));
	string[i]='\0';
	sscanf(string, "%d", &val);
	return *this;
}

IOXTream& IOXTream::operator>> (long& val ){
	char string[80];
	int i=-1;
	do {
		i++;
		string[i]=getche();
	} while ((string[i]!=' ')&&(string[i]!='\n')&&(string[i]!='\r'));
	string[i]='\0';
	sscanf(string, "%d", &val);
	return *this;
}

IOXTream& IOXTream::operator>> (unsigned long& val ){
	char string[80];
	int i=-1;
	do {
		i++;
		string[i]=getche();
	} while ((string[i]!=' ')&&(string[i]!='\n')&&(string[i]!='\r'));
	string[i]='\0';
	sscanf(string, "%d", &val);
	return *this;
}

IOXTream& IOXTream::operator>> (float& val ){
	char string[80];
	int i=-1;
	do {
		i++;
		string[i]=getche();
	} while ((string[i]!=' ')&&(string[i]!='\n')&&(string[i]!='\r'));
	string[i]='\0';
	sscanf(string, "%f", &val);
	return *this;
}

IOXTream& IOXTream::operator>> (double& val ){
	char string[80];
	int i=-1;
	do {
		i++;
		string[i]=getche();
	} while ((string[i]!=' ')&&(string[i]!='\n')&&(string[i]!='\r'));
	string[i]='\0';
	sscanf(string, "%f", &val);
	return *this;
}

IOXTream& IOXTream::operator>> (long double& val ){
	char string[80];
	int i=-1;
	do {
		i++;
		string[i]=getche();
	} while ((string[i]!=' ')&&(string[i]!='\n')&&(string[i]!='\r'));
	string[i]='\0';
	sscanf(string, "%f", &val);
	return *this;
}

/*IOXTream& IOXTream::operator>> (void*& val ){
 return *this;
 }
 
 IOXTream& IOXTream::operator>> (streambuf* sb ){
 return *this;
 }
 
 IOXTream& IOXTream::operator>> (istream& ( *pf )(istream&)){
 return *this;
 }
 
 IOXTream& IOXTream::operator>> (ios& ( *pf )(ios&)){
 return *this;
 }
 
 IOXTream& IOXTream::operator>> (ios_base& ( *pf )(ios_base&)){
 return *this;
 }
 */	
IOXTream& IOXTream::operator>> (char& ch ){
	ch=getche();
	char c=ch;
	do
		c=getche();
	while ((c!=' ')&&(c!='\n')&&(c!='\r'));
	return *this;
}

IOXTream& IOXTream::operator>> (char* str ){
	int i=-1;
	do {
		i++;
		str[i]=getche();
	} while ((str[i]!=' ')&&(str[i]!='\n')&&(str[i]!='\r'));
	str[i]='\0';
	return *this;
}

void textcolor (float r, float g, float b) {
	textColorR=r;
	textColorG=g;
	textColorB=b;
}

void textbackground (float r, float g, float b) {
	textBackR=r;
	textBackG=g;
	textBackB=b;
}
