/*
 *  OpenGLDraw2D.h
 *  SampleScreenSaver
 *
 *  Created by гык-sse2 on 11.07.10.
 *  Copyright 2010 Гимназия 1542. All rights reserved.
 *
 */

#ifndef _CONSOLATION_H
#define _CONSOLATION_H

#ifdef __APPLE__
	#include <GLUT/glut.h>
	#include "SDL.h"
#else
#ifdef WIN32
	#include "SDL.h"
	#include <stdio.h>
	#include "glut.h"
	#pragma warning (disable:4996)
#else
	#include <GL/glut.h>
	#include "SDL/SDL.h"
	#define PT_GLUT_NEEDS_INIT
#endif
#endif
#include <math.h>
#include <stdarg.h>



enum PTFillStyle	{SOLID_FILL, NONE};

#define BLACK			0.00,0.00,0.00
#define BLUE			0.00,0.00,1.00
#define GREEN			0.00,1.00,0.00
#define CYAN			0.00,1.00,1.00
#define RED				1.00,0.00,0.00
#define MAGENTA			1.00,0.00,1.00
#define BROWN			0.67,0.33,0.00
#define LIGHTGRAY		0.67,0.67,0.67
#define DARKGRAY		0.33,0.33,0.33
#define LIGHTBLUE		0.67,0.67,1.00
#define LIGHTGREEN		0.50,1.00,0.50
#define LIGHTCYAN		0.50,1.00,1.00
#define LIGHTRED		1.00,0.67,0.67
#define LIGHTMAGENTA	1.00,0.50,1.00
#define YELLOW			1.00,1.00,0.00
#define WHITE			1.00,1.00,1.00


//Графические функции
//graphics.h
void	initgraph		(int hsize, int vsize, bool fullscreen, int* argc, char** argv);	//Инициализация графики (несовместима с борландом!)
void	closegraph		();											//Завершение графики
void	setbkcolor		(float,float,float);							//Установка цвета фона
void	setcolor		(float,float,float);							//Установка цвета рисования
void	cleardevice		();											//Очистка экрана
void	cleardevicenorefresh	();
void	putpixel		(float x1, float y1);						//Рисование точки
void	line			(float x1, float y1, float x2, float y2);	//Рисование линии
void	bar				(float x1, float y1, float x2, float y2);	//Рисование прямоугольника
void	bar3d			(float x1, float y1, float x2, float y2, float depth, bool topflag);	//Рисование прямоугольного параллелепипеда
void	fillpoly		(int n, float* array);						//Рисование многоугольника
void	outtext			(const char* string);						//Вывод текста в текущих координатах
void	outtextxy		(float x, float y, const char* string);		//Вывод текста в точке с заданными координатами
void	setfillstyle	(PTFillStyle newStyle, float,float,float);	//Установка стиля заполнения
void	fillellipse		(float x0, float y0, float r1, float r2);	//Рисование эллипса

//Вспомогательные функции
void	catchevents		();											//Обработка некоторых событий (нужно для bioskey и закрытия программы по крестику


//Текстовые функции 
//conio.h, stdio.h
void	textcolor		(float red, float green, float blue);		//Цвет текста
void	textbackground	(float red, float green, float blue);		//Цвет фона текста
void	gotoxy			(float x, float y);							//Переход в точку
void	clrscr			();											//Очистка экрана и сброс текстовых координат
char	getch			();											//Чтение символа
int		ptputs			(const char* string);						//Вывод строки
char*	ptgets			(char* string);
char	getche			();											//Чтение символа с выводом на экран
int		putch			(char symbol);								//Вывод символа
void	ptprintf		(const char* format, ...);					//Форматированный вывод
#ifndef WIN32
void	ptscanf			(const char* format, ...);					//Форматированный ввод (не работает в Windows из-за отсутствия функции vsscanf)
#endif

//dos.h
void	delay			(int ms);									//Задержка в миллисекундах
int		bioskey			(int command);								//Биоскей

//Эти функции не входят в стандарты, но это полезное дополнение, позволяющее использовать аппаратное ускорение для простых операций
void	PTPointArray		(float* array, int n);					//Рисование массива точек
void	PTLinedPointArray	(float* array, int n);					//Рисование массива точек, соединенных линиями

class IOXTream{ //BUG: ios_base format flags not handled
public:
	IOXTream& operator<< (bool& val ){ptprintf("%d",val);return *this;}
	IOXTream& operator<< (short& val ){ptprintf("%d",val);return *this;}
	IOXTream& operator<< (unsigned short& val ){ptprintf("%d",val);return *this;}
	IOXTream& operator<< (int& val ){ptprintf("%d",val);return *this;}
	IOXTream& operator<< (unsigned int& val ){ptprintf("%d",val);return *this;}
	IOXTream& operator<< (long& val ){ptprintf("%d",val);return *this;}
	IOXTream& operator<< (unsigned long& val ){ptprintf("%d",val);return *this;}
	IOXTream& operator<< (float& val ){ptprintf("%f",val);return *this;}
	IOXTream& operator<< (double& val ){ptprintf("%f",val);return *this;}
	IOXTream& operator<< (long double& val ){ptprintf("%f",val);return *this;}
	/*IOXTream& operator<< (const void* val );	 
	 IOXTream& operator<< (streambuf* sb );	 
	 IOXTream& operator<< (ostream& ( *pf )(ostream&));
	 IOXTream& operator<< (ios& ( *pf )(ios&));
	 IOXTream& operator<< (ios_base& ( *pf )(ios_base&));*/	
	IOXTream& operator<< (char c ){ptprintf("%c",c);return *this;}	
	IOXTream& operator<< (const char* s ){ptprintf("%s",s);return *this;}
		
	IOXTream& operator>> (bool& val );
	IOXTream& operator>> (short& val );
	IOXTream& operator>> (unsigned short& val );
	IOXTream& operator>> (int& val );
	IOXTream& operator>> (unsigned int& val );
	IOXTream& operator>> (long& val );
	IOXTream& operator>> (unsigned long& val );
	IOXTream& operator>> (float& val );
	IOXTream& operator>> (double& val );
	IOXTream& operator>> (long double& val );
	/*IOXTream& operator>> (void*& val );	
	IOXTream& operator>> (streambuf* sb );	
	IOXTream& operator>> (istream& ( *pf )(istream&));
	IOXTream& operator>> (ios& ( *pf )(ios&));
	IOXTream& operator>> (ios_base& ( *pf )(ios_base&));*/	
	IOXTream& operator>> (char& ch );
	IOXTream& operator>> (char* str );
};

namespace Paztalom {
	static IOXTream cin, cout;
}

#endif //_CONSOLATION_H
